module AMA(
  clk,
  rst,
  in1,
  in2,
  coef,
  Acc
);
input clk;
input rst;
input [15:0] in1;
input [15:0] in2;
input [15:0] coef;
output [15:0] Acc;

reg [15:0] Acc;
wire [16:0] addout;
wire [32:0] multout;

wire [16:0] p0;
wire [16:0] p1;
wire [16:0] p2;
wire [16:0] p3;
wire [16:0] p4;
wire [16:0] p5;
wire [16:0] p6;
wire [16:0] p7;
wire [16:0] p8;
wire [16:0] p9;
wire [16:0] p10;
wire [16:0] p11;
wire [16:0] p12;
wire [16:0] p13;
wire [16:0] p14;
wire [16:0] p15;

assign addout = {in1[15], in1} + {in2[15], in2};

assign p0 = (coef[0])? addout : 17'h0;
assign p1 = (coef[1])? addout : 17'h0;
assign p2 = (coef[2])? addout : 17'h0;
assign p3 = (coef[3])? addout : 17'h0;
assign p4 = (coef[4])? addout : 17'h0;
assign p5 = (coef[5])? addout : 17'h0;
assign p6 = (coef[6])? addout : 17'h0;
assign p7 = (coef[7])? addout : 17'h0;
assign p8 = (coef[8])? addout : 17'h0;
assign p9 = (coef[9])? addout : 17'h0;
assign p10 = (coef[10])? addout : 17'h0;
assign p11 = (coef[11])? addout : 17'h0;
assign p12 = (coef[12])? addout : 17'h0;
assign p13 = (coef[13])? addout : 17'h0;
assign p14 = (coef[14])? addout : 17'h0;
assign p15 = (coef[15])? (~addout+1) : 17'h0;
`ifdef DESIGN_WARE
DW02_sum #(16, 33) u1(
  .INPUT({
    {{1{p15[16]}},p15,15'h0},
    {{2{p14[16]}},p14,14'h0},
    {{3{p13[16]}},p13,13'h0},
    {{4{p12[16]}},p12,12'h0},
    {{5{p11[16]}},p11,11'h0},
    {{6{p10[16]}},p10,10'h0},
    {{7{p9[16]}},p9,9'h0},
    {{8{p8[16]}},p8,8'h0},
    {{9{p7[16]}},p7,7'h0},
    {{10{p6[16]}},p6,6'h0},
    {{11{p5[16]}},p5,5'h0},
    {{12{p4[16]}},p4,4'h0},
    {{13{p3[16]}},p3,3'h0},
    {{14{p2[16]}},p2,2'h0},
    {{15{p1[16]}},p1,1'h0},
    {{16{p0[16]}},p0}}
  ),

  .SUM(multout)
);
`else
p_add u1(
	.data0x({{1{p15[16]}},p15,15'h0}),
	.data10x({{2{p14[16]}},p14,14'h0}),
	.data11x({{3{p13[16]}},p13,13'h0}),
	.data12x({{4{p12[16]}},p12,12'h0}),
	.data13x({{5{p11[16]}},p11,11'h0}),
	.data14x({{6{p10[16]}},p10,10'h0}),
	.data15x({{7{p9[16]}},p9,9'h0}),
	.data1x({{8{p8[16]}},p8,8'h0}),
	.data2x({{9{p7[16]}},p7,7'h0}),
	.data3x({{10{p6[16]}},p6,6'h0}),
	.data4x({{11{p5[16]}},p5,5'h0}),
	.data5x({{12{p4[16]}},p4,4'h0}),
	.data6x({{13{p3[16]}},p3,3'h0}),
	.data7x({{14{p2[16]}},p2,2'h0}),
	.data8x({{15{p1[16]}},p1,1'h0}),
	.data9x({{16{p0[16]}},p0}),
	.result(multout)
);

`endif

/*
assign multout = 
    + {{1{p15[16]}},p15,15'h0}
    + {{2{p14[16]}},p14,14'h0}
    + {{3{p13[16]}},p13,13'h0}
    + {{4{p12[16]}},p12,12'h0}
    + {{5{p11[16]}},p11,11'h0}
    + {{6{p10[16]}},p10,10'h0}
    + {{7{p9[16]}},p9,9'h0}
    + {{8{p8[16]}},p8,8'h0}
    + {{9{p7[16]}},p7,7'h0}
    + {{10{p6[16]}},p6,6'h0}
    + {{11{p5[16]}},p5,5'h0}
    + {{12{p4[16]}},p4,4'h0}
    + {{13{p3[16]}},p3,3'h0}
    + {{14{p2[16]}},p2,2'h0}
    + {{15{p1[16]}},p1,1'h0}
    + {{16{p0[16]}},p0};
*/
/*
DW02_mult #(17, 16) u_mult(
  .A(addout),
  .B(coef),
  .TC(1'b1),
  .PRODUCT(multout)
);
*/

always @(posedge clk)
begin
  if (rst)
    Acc <= 34'h0;
  else
    Acc <= Acc + multout[32:15];
end

endmodule
